/*
 stund.c

 Author: Allan Latham <alatham@flexsys-group.com>

 Copyright (c) 1997. The terms of the following licence apply.

                       **** WARNING ****

This program provides the means to establish an IP link via the TCP layer
and can therefore be used to defeat many features of firewall systems.
The author is in no way responsible for any consequences arising out of its
use. If you have any doubts whether you should be using it you should check
with the appropriate authoritive person within your organisation.

                      ****************** 


		    GNU GENERAL PUBLIC LICENSE
		       Version 2, June 1991

 Copyright (C) 1989, 1991 Free Software Foundation, Inc.
                          675 Mass Ave, Cambridge, MA 02139, USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

			    Preamble

  The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

  We protect your rights with two steps: (1) copyright the software, and
(2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

  Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

  Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

  The precise terms and conditions for copying, distribution and
modification follow.

		    GNU GENERAL PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains
a notice placed by the copyright holder saying it may be distributed
under the terms of this General Public License.  The "Program", below,
refers to any such program or work, and a "work based on the Program"
means either the Program or any derivative work under copyright law:
that is to say, a work containing the Program or a portion of it,
either verbatim or with modifications and/or translated into another
language.  (Hereinafter, translation is included without limitation in
the term "modification".)  Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope.  The act of
running the Program is not restricted, and the output from the Program
is covered only if its contents constitute a work based on the
Program (independent of having been made by running the Program).
Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
source code as you receive it, in any medium, provided that you
conspicuously and appropriately publish on each copy an appropriate
copyright notice and disclaimer of warranty; keep intact all the
notices that refer to this License and to the absence of any warranty;
and give any other recipients of the Program a copy of this License
along with the Program.

You may charge a fee for the physical act of transferring a copy, and
you may at your option offer warranty protection in exchange for a fee.

  2. You may modify your copy or copies of the Program or any portion
of it, thus forming a work based on the Program, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:

    a) You must cause the modified files to carry prominent notices
    stating that you changed the files and the date of any change.

    b) You must cause any work that you distribute or publish, that in
    whole or in part contains or is derived from the Program or any
    part thereof, to be licensed as a whole at no charge to all third
    parties under the terms of this License.

    c) If the modified program normally reads commands interactively
    when run, you must cause it, when started running for such
    interactive use in the most ordinary way, to print or display an
    announcement including an appropriate copyright notice and a
    notice that there is no warranty (or else, saying that you provide
    a warranty) and that users may redistribute the program under
    these conditions, and telling the user how to view a copy of this
    License.  (Exception: if the Program itself is interactive but
    does not normally print such an announcement, your work based on
    the Program is not required to print an announcement.)
 
These requirements apply to the modified work as a whole.  If
identifiable sections of that work are not derived from the Program,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works.  But when you
distribute the same sections as part of a whole which is a work based
on the Program, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Program.

In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
under Section 2) in object code or executable form under the terms of
Sections 1 and 2 above provided that you also do one of the following:

    a) Accompany it with the complete corresponding machine-readable
    source code, which must be distributed under the terms of Sections
    1 and 2 above on a medium customarily used for software interchange; or,

    b) Accompany it with a written offer, valid for at least three
    years, to give any third party, for a charge no more than your
    cost of physically performing source distribution, a complete
    machine-readable copy of the corresponding source code, to be
    distributed under the terms of Sections 1 and 2 above on a medium
    customarily used for software interchange; or,

    c) Accompany it with the information you received as to the offer
    to distribute corresponding source code.  (This alternative is
    allowed only for noncommercial distribution and only if you
    received the program in object code or executable form with such
    an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for
making modifications to it.  For an executable work, complete source
code means all the source code for all modules it contains, plus any
associated interface definition files, plus the scripts used to
control compilation and installation of the executable.  However, as a
special exception, the source code distributed need not include
anything that is normally distributed (in either source or binary
form) with the major components (compiler, kernel, and so on) of the
operating system on which the executable runs, unless that component
itself accompanies the executable.

If distribution of executable or object code is made by offering
access to copy from a designated place, then offering equivalent
access to copy the source code from the same place counts as
distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.
 
  4. You may not copy, modify, sublicense, or distribute the Program
except as expressly provided under this License.  Any attempt
otherwise to copy, modify, sublicense or distribute the Program is
void, and will automatically terminate your rights under this License.
However, parties who have received copies, or rights, from you under
this License will not have their licenses terminated so long as such
parties remain in full compliance.

  5. You are not required to accept this License, since you have not
signed it.  However, nothing else grants you permission to modify or
distribute the Program or its derivative works.  These actions are
prohibited by law if you do not accept this License.  Therefore, by
modifying or distributing the Program (or any work based on the
Program), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
Program), the recipient automatically receives a license from the
original licensor to copy, distribute or modify the Program subject to
these terms and conditions.  You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.

  7. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Program at all.  For example, if a patent
license would not permit royalty-free redistribution of the Program by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under
any particular circumstance, the balance of the section is intended to
apply and the section as a whole is intended to apply in other
circumstances.

It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system, which is
implemented by public license practices.  Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.

This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.
 
  8. If the distribution and/or use of the Program is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Program under this License
may add an explicit geographical distribution limitation excluding
those countries, so that distribution is permitted only in or among
countries not thus excluded.  In such case, this License incorporates
the limitation as if written in the body of this License.

  9. The Free Software Foundation may publish revised and/or new versions
of the General Public License from time to time.  Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

Each version is given a distinguishing version number.  If the Program
specifies a version number of this License which applies to it and "any
later version", you have the option of following the terms and conditions
either of that version or of any later version published by the Free
Software Foundation.  If the Program does not specify a version number of
this License, you may choose any version ever published by the Free Software
Foundation.

  10. If you wish to incorporate parts of the Program into other free
programs whose distribution conditions are different, write to the author
to ask for permission.  For software which is copyrighted by the Free
Software Foundation, write to the Free Software Foundation; we sometimes
make exceptions for this.  Our decision will be guided by the two goals
of preserving the free status of all derivatives of our free software and
of promoting the sharing and reuse of software generally.

			    NO WARRANTY

  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

		     END OF TERMS AND CONDITIONS
*/

/*                          REVISION HISTORY

25-JUN-97  0.12  First release available to the outside world.
25-JUN-97  0.13  Don't bring up the interface until the TCP link is ready.
                 Exchange ID on TCP link start up.
                 Optionally exchange arguments (-a).
                 Add routes (-LNR)
*/ 

#define ENCAP_SLIP    0      /* slip */
#define ENCAP_VJ      1      /* VJ slip */
#define LEN_IP 16
#define FALSE 0
#define TRUE 1

#include "version.h"
#include "config.h"

#include <string.h>
#include <stdlib.h> 
#include <stdio.h>   
#include <unistd.h>   
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stddef.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <linux/interface_flags.h>
#include <netdb.h>

/* prototypes */

void add_route(char*, char*);
void add_default_route();
int check_interface();
void configure_interface();
void daemonic();
void display_arguments();
void display_hello();
void forward_traffic();
void get_arguments(int, char**);
void get_pty();
void interface_up();
void negotiate();
void read_newsock(void*, int, int*);
void set_up_tty(int);
void socket_up();
void write_newsock(void*, int);

/* globals */

char *av0;
char **saved_argv;

FILE *pmfp;

struct aftype *ap;
struct sockaddr_in sal;
struct sockaddr_in sar;
struct sockaddr_in san;

int pmfd;
int psfd;
int iface;
int orig_disc;
int newsock;
int skfd;

char siface[5];

/* arguments to main */

char local_IP_address[LEN_IP];
char remote_IP_address[LEN_IP];
char netmask[LEN_IP];
int paccept = FALSE;
int route_local = FALSE;
int route_remote = FALSE;
int route_net = FALSE;
int route_default = FALSE;
int mtu = 0;
int debug = 0;
unsigned int transmit_port = 0;
unsigned int receive_port = 0;

/* ---------------------------------------------------------------- */
int main(int ac, char **av)
{

/* FIXME - Signal handlers */

 skfd = socket(AF_INET, SOCK_DGRAM, 0);
 if (skfd < 0)
 {
  fprintf(stderr, "socket(skfd): %.100s\n", strerror(errno));
  exit(-1);
 }

 display_hello();
 get_arguments(ac, av);
 display_arguments();
 socket_up();
 negotiate();
 get_pty();
 interface_up();
 if (route_local)
 {
  add_route(local_IP_address, NULL);
 }
 if (route_remote)
 {
  add_route(remote_IP_address, NULL);
 }
 if (route_net)
 {
  if (netmask[0] == 0)
  {
   add_route(remote_IP_address, "255.255.255.0");
  }
  else
  {
   add_route(remote_IP_address, netmask);
  }
 }
 if (route_default)
 {
  add_default_route();
 }
 daemonic();
 forward_traffic();  
 exit(0);
}

/* ---------------------------------------------------------------- */
void negotiate()
{
 int len;

 struct exchange
 {
  int pa;
  int mtu;
  char id[20];
  char lip[LEN_IP];
  char rip[LEN_IP];
  char mask[LEN_IP];
 } tx, rx;

 struct in_addr addr;

 tx.pa = paccept;
 tx.mtu = mtu;
 sprintf(tx.id, "STUND: %s %s", VERSION, PRIVATE_IDENT);
 strcpy (tx.lip, local_IP_address);
 strcpy (tx.rip, remote_IP_address);
 strcpy (tx.mask, netmask);

 write_newsock(&tx, sizeof(tx)); 

 read_newsock(&rx, sizeof(rx), &len);
 
 if (strcmp(tx.id, rx.id))
 {
  if (debug > 1)
  {
   fprintf(stderr, "logon failed: got = %s, wanted =  %s\n", rx.id, tx.id);
  }
  exit (1);
 }
 else
 {
  if (tx.pa && rx.pa)
  {
   if (debug > 1)
   {
    fprintf(stderr, "Both sides want to accept IP details\n");
   }
   exit (1);
  }
  if (tx.pa)
  {
   if (debug > 1)
   {
    printf("Peer gives me %s\n", rx.rip);
   }
   if (debug > 1)
   {
    printf("Peer tells me he is %s\n", rx.lip);
   }
   if (debug > 1)
   {
    if (rx.mask[0] == 0)
    {
     printf("Peer sets a netmask of default\n");
    }
    else
    {
     printf("Peer sets a netmask of %s\n", rx.mask);
    }
   }
   if (debug > 1)
   {
    printf("Peer sets an mtu of %d\n", rx.mtu);
   }
   strcpy (local_IP_address, rx.rip);
   strcpy (remote_IP_address, rx.lip);
   strcpy (netmask, rx.mask);
   mtu = rx.mtu;
  }
  else
  {
   if (rx.pa)
   {
    if (debug > 1)
    {
     printf("Peer accepts my details\n");
    }
   }
   else
   {
    if (debug > 1)
    {
     printf("Peer thinks I am %s\n", rx.rip);
    }
    if (debug > 1)
    {
     printf("Peer tells me he is %s\n", rx.lip);
    }
    if (debug > 1)
    {
     printf("Peer has a netmask of %s\n", rx.mask);
    }
    if (debug > 1)
    {
     printf("Peer has an mtu of %d\n", rx.mtu);
    }
   }
  }
 }

 inet_aton(local_IP_address, &addr);
 sal.sin_family = AF_INET;
 sal.sin_port = 0;
 sal.sin_addr = addr;

 inet_aton(remote_IP_address, &addr);
 sar.sin_family = AF_INET;
 sar.sin_port = 0;
 sar.sin_addr = addr;

 if (netmask[0] != 0)
 {
  inet_aton(netmask, &addr);
  san.sin_family = AF_INET;
  san.sin_port = 0;
  san.sin_addr = addr;
 }
}

/* ---------------------------------------------------------------- */
void forward_traffic()
{
 fd_set rfds;
 struct timeval tv;
 unsigned char buf[BUFFSIZE];
 int max, len, ret, bufl;

 bufl = mtu * 2;

 if (newsock > pmfd)
 { 
  max = newsock + 1;
 }
 else
 { 
  max = pmfd + 1;
 }
 for (;;)
 {
  FD_ZERO(&rfds);
  FD_SET(pmfd, &rfds);
  FD_SET(newsock, &rfds);
  tv.tv_sec = 5;
  tv.tv_usec = 0;
  ret = select(max, &rfds, NULL, NULL, &tv);

  if (ret == 0)
  {
   if (check_interface(siface))
   {
    exit(0);
   }
  } 
  if (FD_ISSET(pmfd, &rfds))
  {
   len = read(pmfd, buf, bufl);
   if (len < 1)
   {
    exit(0);
   }
   else
   {
    write_newsock(buf, len);
   }
  }
  if (FD_ISSET(newsock, &rfds))
  {
   read_newsock(buf, bufl, &len); 
   if (write(pmfd, buf, len) != len)
   {
    if (debug > 1)
    {
     fprintf(stderr, "write(pmfd): %.100s\n", strerror(errno));
    }
    exit (1);
   } 
  }
 }
}

/* ---------------------------------------------------------------- */
void get_pty()
{
 char *ptys = "0123456789abcdef";
 int i, c;
 static char buf[16];

 for (c = 'p'; c <= 's'; c++)
 { 
  for (i = 0; i < 16; i++)
  {
   sprintf(buf, "/dev/pty%c%c", c, ptys[i]);
   if ((pmfd = open(buf, O_RDWR)) >= 0)
   {
    sprintf(buf, "/dev/tty%c%c", c, ptys[i]);
    if ((psfd = open(buf, O_RDWR | O_NOCTTY | O_NDELAY)) < 0)
    {
     fprintf(stderr, "slave pty open: %.100s\n", strerror(errno));
     exit(-1);
    }
    pmfp = fdopen(pmfd, "r+");
    return;
   }
  }
 }
}

/* ---------------------------------------------------------------- */
void interface_up()
{

 int disc = N_SLIP;
 int encap = ENCAPSULATION;

 set_up_tty(psfd);
 set_up_tty(pmfd);

 if (ioctl(psfd, TIOCGETD, &orig_disc) < 0)
 {
  fprintf(stderr, "get original line discipline: %.100s\n", strerror(errno));
  exit(-1);
 }

 if ((iface = ioctl(psfd, TIOCSETD, &disc)) < 0)
 {
  fprintf(stderr, "set new line discipline: %.100s\n", strerror(errno));
  exit(-1);
 }

 if (ioctl(psfd, SIOCSIFENCAP, &encap) < 0)
 {
  fprintf(stderr, "set new encapsulation: %.100s\n", strerror(errno));
  exit(-1);
 }

 if (ioctl(psfd, TIOCGETD, &disc) < 0)
 {
  fprintf(stderr, "get new line discipline: %.100s\n", strerror(errno));
  exit(-1);
 }

 if (ioctl(psfd, SIOCGIFENCAP, &encap) < 0)
 {
  fprintf(stderr, "get new encapsulation: %.100s\n", strerror(errno));
  exit(-1);
 }

 if (disc != N_SLIP || encap != ENCAPSULATION)
 {
  fprintf(stderr, "link setup failed\n");
  exit(-1);
 }

 sprintf(siface,"sl%d",iface);
 printf("Tunnel interface  is %s\n", siface);

 configure_interface();

}

/* FIX ME return the pty to its original state when we finish */

/* ---------------------------------------------------------------- */
void socket_up()
{
 int listen_sock;
 int aux, on = 1;
 struct sockaddr_in si, so;
 struct in_addr loopback;
 listen_sock = socket(AF_INET, SOCK_STREAM, 0);
 if (listen_sock < 0)
 {
  fprintf(stderr, "socket: %.100s\n", strerror(errno));
  exit(-1);
 }

 setsockopt(listen_sock, SOL_SOCKET, SO_REUSEADDR, (void *)&on, sizeof(on));

 memset(&si, 0, sizeof(si));
 si.sin_family = AF_INET;

 if (receive_port != 0)                        /* Server mode */
 {
  loopback.s_addr = INADDR_ANY;
  si.sin_addr = loopback;
  si.sin_port = htons(receive_port);
  if (bind(listen_sock, (struct sockaddr *)&si, sizeof(si)) < 0)
  {
   fprintf(stderr, "bind: %.100s\n", strerror(errno));
   shutdown(listen_sock, 2);
   close(listen_sock);
   exit(-1);
  }
  if (listen(listen_sock, 1) < 0)
  {
   fprintf(stderr, "listen: %.100s\n", strerror(errno));
   shutdown(listen_sock, 2);
   close(listen_sock);
   exit(-1);
  }
  printf("Waiting for client to connect\n");
  newsock = 0;
  while(newsock < 1) 
  {
   aux = sizeof(so);
   newsock = accept(listen_sock, (struct sockaddr *)&so, &aux);
   if (newsock < 0)
   {
    if (errno == EINTR)
    {
     continue;
    }
    fprintf(stderr, "accept: %.100s\n", strerror(errno));
    continue;
   }
  }
  close(listen_sock);
 }
 else                                 /* Client mode */
 {
  inet_aton("127.0.0.1", &loopback);
  si.sin_addr = loopback;
  si.sin_port = htons(transmit_port);
  if (connect(listen_sock, (struct sockaddr *)&si, sizeof(si)) < 0)
  {
   fprintf(stderr, "connect: %.100s\n", strerror(errno));
   shutdown(listen_sock, 2);
   close(listen_sock);
   exit(-1);
  }
  newsock = listen_sock;
 }
 printf("Socket link established\n");
}

/* ---------------------------------------------------------------- */
void set_up_tty(int fd)
{
 int i;
 struct termios tios;

 if (tcgetattr(fd, &tios) < 0)
 {
  fprintf(stderr, "get terminal attributes: %.100s\n", strerror(errno));
  exit(-1);
 }

 tios.c_cflag = CS8 | CREAD | HUPCL;
 tios.c_cflag |= CLOCAL;
 tios.c_iflag = IGNBRK | IGNPAR;
 tios.c_oflag = 0;
 tios.c_lflag = 0;
 for (i = 0; i < NCCS; i++)
 {
  tios.c_cc[i] = 0;
 }  
 tios.c_cc[VMIN] = 1;
 tios.c_cc[VTIME] = 0;

 cfsetospeed(&tios, 115200);
 cfsetispeed(&tios, 115200);

 if (tcsetattr(fd, TCSAFLUSH, &tios) < 0)
 {
  fprintf(stderr, "set terminal attributes: %.100s\n", strerror(errno));
  exit(-1);
 }
}

/* ---------------------------------------------------------------- */
void get_arguments(int ac, char **av)
{
 extern char *optarg;
 extern int optind;

 int opt;

 netmask[0] = 0;
 local_IP_address[0] = 0;
 remote_IP_address[LEN_IP-1] = 0;
 saved_argv = av;
 if (strchr(av[0], '/'))
 {
  av0 = strrchr(av[0], '/') + 1;
 }
 else
 {
  av0 = av[0];
 }
 while ((opt = getopt(ac, av, "c:d:l:m:n:r:s:DLRNah?")) != EOF)
 {
  switch (opt)
  {
   case 'a':
    paccept = TRUE;
    break;
   case 'c':
    transmit_port = atoi(optarg);
    break;
   case 'd':
    debug = atoi(optarg);
    break;
   case 'l':
    strncpy(local_IP_address, optarg, LEN_IP);
    local_IP_address[LEN_IP-1] = 0;
    break;
   case 'm':
    mtu = atoi(optarg);
    break;
   case 'n':
    strncpy(netmask, optarg, LEN_IP);
    netmask[LEN_IP-1] = 0;
    break;
   case 'r':
    strncpy(remote_IP_address, optarg, LEN_IP);
    remote_IP_address[LEN_IP-1] = 0;
    break;
   case 's':
    receive_port = atoi(optarg);
    break;
   case 'D':
    route_default = TRUE;
    break;
   case 'L':
    route_local = TRUE;
    break;
   case 'N':
    route_net = TRUE;
    break;
   case 'R':
    route_remote = TRUE;
    break;
   case '?':
   case 'h':
   default:
    fprintf(stderr, "stund ");
    fprintf(stderr, "Usage: %s [options]\n", av0);
    fprintf(stderr, "Options:\n");
    fprintf(stderr, "  -a              accept IPs, netmask and mtu from peer\n");
    fprintf(stderr, "  -c port         client mode port\n");
    fprintf(stderr, "  -d debug_level  2 or above = keep in foreground\n");
    fprintf(stderr, "  -h or -?        this help message\n");
    fprintf(stderr, "  -l address      local IP of the stun interface\n");
    fprintf(stderr, "  -m bytes        mtu *** same for client and server ***\n");
    fprintf(stderr, "  -n netmask      netmask of the stun interface\n");
    fprintf(stderr, "  -r address      remote IP of the stun interface\n");
    fprintf(stderr, "  -s port         server mode port\n");
    fprintf(stderr, "  -D              make this interface the default route\n");
    fprintf(stderr, "  -L              add route to local address\n");
    fprintf(stderr, "  -N              add route to remote network\n");
    fprintf(stderr, "  -R              add route to remote address\n");
    fprintf(stderr, "Returns:\n");
    fprintf(stderr, "  100 + slip interface number i.e. 101 means sl1\n");
    fprintf(stderr, "  -1 if there was an error\n\n");
    exit(-1);
  }
 }
 if (optind < ac)
 {
  fprintf(stderr, "Extra argument %s.\n", av[optind]);
  exit(-1);
 }

 if (paccept)
 {
  if (local_IP_address[0] != 0)
  {
   fprintf(stderr, "Local IP address conflicts with -a\n");
   exit(-1);
  }
  if (remote_IP_address[0] != 0)
  {
   fprintf(stderr, "Remote IP address conflicts with -a\n");
   exit(-1);
  }
  if (netmask[0] != 0)
  {
   fprintf(stderr, "Netmask conflicts with -a\n");
   exit(-1);
  }
  if (mtu != 0)
  {
   fprintf(stderr, "MTU conflicts with -a\n");
   exit(-1);
  }
 }
 else
 {
  if (local_IP_address[0] == 0)
  {
   fprintf(stderr, "Local IP address missing\n");
   exit(-1);
  }
  if (remote_IP_address[0] == 0)
  {
   fprintf(stderr, "Remote IP address missing\n");
   exit(-1);
  }
  if (mtu == 0)
  { 
   mtu = DEFAULT_MTU;
  }
  if ((mtu < 100) || (mtu > MAXMTU)) 
  {
   fprintf(stderr, "MTU must be > 99 and < %d\n", BUFFSIZE);
   exit(-1);
  }
 }

 if ((transmit_port == 0) && (receive_port == 0)) 
 {
  fprintf(stderr, "Server/Cient port missing\n");
  exit(-1);
 }
 if ((transmit_port != 0) && (receive_port != 0)) 
 {
  fprintf(stderr, "Server and client ports cannot both be given\n");
  exit(-1);
 }
}

/* ---------------------------------------------------------------- */
void daemonic()
{
 int fd;

 if (debug < 2)
 {
  printf("\nNow going into the background\n\n");
  if (fork())
  {
   exit(iface + 100);
  }
  else
  {
   freopen("/dev/null", "r", stdin);
   freopen("/dev/null", "w", stdout);
   freopen("/dev/null", "w", stderr);
   fd = open("/dev/tty", O_RDWR|O_NOCTTY);
   if (fd >= 0)
   {
    ioctl(fd, TIOCNOTTY, NULL);
    close(fd);
   }
   chdir("/");
  }
 }
}

/* ---------------------------------------------------------------- */
void display_hello()
{
 printf("\nSTUND version %s, Copyright (C) 1997 Allan Latham <alatham@flexsys-group.com>\n", VERSION);
 printf("      IP tunnel through the TCP layer. Ideal for use with \"ssh\" or \"term\".\n");
 printf("      STUND comes with ABSOLUTELY NO WARRANTY. Use it at YOUR OWN RISK.\n");
 printf("      This is free software; you are welcome to redistribute it\n");
 printf("      or modify it under certain conditions; see source for details.\n\n");
}

/* ---------------------------------------------------------------- */
void display_arguments()
{
 if (paccept)
 {
  printf("Local  IP address is to be set by peer\n");
  printf("Remote IP address is to be set by peer\n");
  printf("Network mask      is to be set by peer\n");
  printf("MTU               is to be set by peer\n");
 }
 else
 {
  printf("Local  IP address is %s\n", local_IP_address);
  printf("Remote IP address is %s\n", remote_IP_address);
  if (netmask[0])
  {
   printf("Network mask      is %s\n", netmask);
  }
  else
  {
   printf("Network mask      is default\n");
  }
  printf("MTU               is %d\n", mtu);
 }
 if (transmit_port)
 {
  printf("Client mode port  is %d\n", transmit_port);
 }
 else
 {
  printf("Server mode port  is %d\n", receive_port);
 }
}

/* ---------------------------------------------------------------- */
int check_interface()
{
 struct ifreq ifr;

 strcpy(ifr.ifr_name, siface);
 if (ioctl(skfd, SIOCGIFFLAGS, &ifr) < 0)
 {
  return(-1);
 }
 if (ifr.ifr_flags & IFF_UP)
 {
  return(0);
 }
 return(-1);
}

/* ---------------------------------------------------------------- */
void configure_interface()
{
 struct ifreq ifr;

 strcpy(ifr.ifr_name, siface);

 ifr.ifr_flags = IFF_NOARP | IFF_NOTRAILERS 
                                 | IFF_UP | IFF_RUNNING | IFF_POINTOPOINT;

 if (ioctl(skfd, SIOCSIFFLAGS, &ifr) < 0)
 {
  fprintf(stderr, "SIOCSIFFLAGS: %.100s\n", strerror(errno));
  exit(-1);
 }

 ifr.ifr_metric = 1;
 if (ioctl(skfd, SIOCSIFMETRIC, &ifr) < 0)
 {
  fprintf(stderr, "SIOCSIFMETRIC: %.100s\n", strerror(errno));
  exit(-1);
 }

 ifr.ifr_mtu = mtu;
 if (ioctl(skfd, SIOCSIFMTU, &ifr) < 0)
 {
  fprintf(stderr, "SIOCSIFMTU: %.100s\n", strerror(errno));
  exit(-1);
 }

 if (netmask[0] != 0)
 {
  memcpy((char *) &ifr.ifr_netmask, (char *) &san, sizeof(struct sockaddr));
  if (ioctl(skfd, SIOCSIFNETMASK, &ifr) < 0)
  {
   fprintf(stderr, "SIOCSIFNETMASK: %.100s\n", strerror(errno));
   exit(-1);
  }
 }

 memcpy((char *) &ifr.ifr_dstaddr, (char *) &sar, sizeof(struct sockaddr));
 if (ioctl(skfd, SIOCSIFDSTADDR, &ifr) < 0)
 {
  fprintf(stderr, "SIOCSIFDSTADDR: %.100s\n", strerror(errno));
  exit(-1);
 }

 memcpy((char *) &ifr.ifr_addr, (char *) &sal, sizeof(struct sockaddr));
 
 if (ioctl(skfd, SIOCSIFADDR, &ifr) < 0)
 {
  fprintf(stderr, "SIOCSIFADDR: %.100s\n", strerror(errno));
  exit(-1);
 }
}

/* ---------------------------------------------------------------- */
void write_newsock(void *from, int length)
{
 if (debug > 5)
 {
  printf("xmit length = %d\n", length);
 }   
 if (write(newsock, from, length) != length)
 {
  if (debug > 1)
  {
   fprintf(stderr, "write(newsock): %.100s\n", strerror(errno));
  }
  exit (1);
 }
}

/* ---------------------------------------------------------------- */
void read_newsock(void *buffer, int maxsize, int *length)
{
 *length = read(newsock, buffer, maxsize);
 if (*length < 1)
 {
  exit(0);
 }
 if (debug > 5)
 {
  printf("recv length = %d\n", *length);
 }   
}

/* ---------------------------------------------------------------- */
void add_route(char *IPaddress, char* mask)
{
 struct in_addr IPaddr;
 struct in_addr IPmask;
 char buf[128];
 char masked[16];

 if (mask == NULL)
 {
  if (debug > 1)
  {
   printf("adding host route to %s via %s\n", IPaddress, siface);
  }
  sprintf(buf, "%s add %s %s\n", PATH_TO_ROUTE, IPaddress, siface);
 }
 else
 {
  inet_aton(IPaddress, &IPaddr);
  inet_aton(mask, &IPmask);
  IPaddr.s_addr = IPaddr.s_addr & IPmask.s_addr;
  strcpy (masked, inet_ntoa(IPaddr));
  if (debug > 1)
  {
   printf("adding network route to %s via %s\n", masked, siface);
  }
  sprintf(buf, "%s add -net %s netmask %s %s\n", PATH_TO_ROUTE,
                                                  masked, mask, siface);
 }
 system(buf);
}

/* ---------------------------------------------------------------- */
void add_default_route()
{
 char buf[128];

 if (debug > 1)
 {
  printf("deleting any existing default route\n");
 }
 sprintf(buf, "%s del default 2>/dev/null\n", PATH_TO_ROUTE);
 system(buf);
 if (debug > 1)
 {
  printf("adding default route via %s\n", siface);
 }
 sprintf(buf, "%s add default %s\n", PATH_TO_ROUTE, siface);
 system(buf);
}
